﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace WindowsFormTemplateCs
{
    public partial class Explorer1 : Form
    {
        public Explorer1()
        {
            InitializeComponent();
        }

        private void Explorer1_Load(object sender, EventArgs e)
        {
            //Dim mydocument As String =
            //    Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments)
            //SetUpListViewColumns()
            //Call LoadTree(mydocument,
            //              Me.TreeView.Nodes.Add(mydocument).Nodes)
            string mydocument = 
                Environment.GetFolderPath(Environment.SpecialFolder.MyDocuments);
            SetUpListViewColumns();
            LoadTree(mydocument,
                this.TreeView.Nodes.Add(mydocument).Nodes);
        }

        private void LoadTree(string folder, TreeNodeCollection node)
        {
            //    Try
            //        For Each directory As String In System.IO.Directory.GetDirectories(folder)
            //            Dim tvNode As TreeNode = node.Add(directory.Substring(folder.Length + 1))
            //            Call LoadTree(directory, tvNode.Nodes)
            //        Next
            //    Catch ex As Exception
            //    End Try
            try 
	        {
                foreach (String directory in System.IO.Directory.GetDirectories(folder))
                {
                    TreeNode tvNode = node.Add(directory.Substring(folder.Length + 1));
                    LoadTree(directory, tvNode.Nodes);
                }
	        }
	        catch (Exception)
	        {
	        }
        }

        private void LoadListView(string folder)
        {
            //Dim lvItem As ListViewItem
            //ListView.Items.Clear()
            //Try
            //    For Each file As String In System.IO.Directory.GetFiles(folder)
            //        lvItem = ListView.Items.Add(System.IO.Path.GetFileName(file))
            //        lvItem.ImageKey = "Graph1"
            //        lvItem.SubItems.AddRange(New String() {"列2", "列3"})
            //    Next
            //Catch ex As Exception
            //End Try
            ListViewItem lvItem;
            ListView.Items.Clear();
            try
            {
                foreach (string file in System.IO.Directory.GetFiles(folder))
                {
                    lvItem = ListView.Items.Add(System.IO.Path.GetFileName(file));
                    lvItem.ImageKey = "Graph1";
                    lvItem.SubItems.AddRange(new String[] { "列2", "列3" });
                }
            }
            catch (Exception)
            {
            }
        }

        private void SetUpListViewColumns()
        {
            //    Dim lvColumnHeader As ColumnHeader

            //    SetView(View.SmallIcon)

            //    lvColumnHeader = ListView.Columns.Add("列1")
            //    lvColumnHeader.Width = 90

            //    SetView(View.Details)

            //    lvColumnHeader.Width = 100

            //    lvColumnHeader = ListView.Columns.Add("列2")
            //    lvColumnHeader.Width = 70

            //    lvColumnHeader = ListView.Columns.Add("列3")
            //    lvColumnHeader.Width = 70
            ColumnHeader lvColumnHeader;

            SetView(View.SmallIcon);

            lvColumnHeader = ListView.Columns.Add("列1");
            lvColumnHeader.Width = 90;

            SetView(View.Details);

            lvColumnHeader.Width = 100;

            lvColumnHeader = ListView.Columns.Add("列2");
            lvColumnHeader.Width = 70;

            lvColumnHeader = ListView.Columns.Add("列3");
            lvColumnHeader.Width = 70;
        }

        private void ExitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //    Me.Close()
            this.Close();
        }

        private void ToolBarToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //    ToolBarToolStripMenuItem.Checked = Not ToolBarToolStripMenuItem.Checked
            //    ToolStrip.Visible = ToolBarToolStripMenuItem.Checked
            ToolBarToolStripMenuItem.Checked = !ToolBarToolStripMenuItem.Checked;
            ToolStrip.Visible = ToolBarToolStripMenuItem.Checked;
        }

        private void StatusBarToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //    StatusBarToolStripMenuItem.Checked = Not StatusBarToolStripMenuItem.Checked
            //    StatusStrip.Visible = StatusBarToolStripMenuItem.Checked
            StatusBarToolStripMenuItem.Checked = !StatusBarToolStripMenuItem.Checked;
            StatusStrip.Visible = StatusBarToolStripMenuItem.Checked;
        }

        private void ToggleFoldersVisible()
        {
            //    FoldersToolStripMenuItem.Checked = Not FoldersToolStripMenuItem.Checked
            //    FoldersToolStripButton.Checked = FoldersToolStripMenuItem.Checked
            //    Me.SplitContainer.Panel1Collapsed = Not FoldersToolStripMenuItem.Checked
            FoldersToolStripMenuItem.Checked = !FoldersToolStripMenuItem.Checked;
            FoldersToolStripButton.Checked = FoldersToolStripMenuItem.Checked;
            this.SplitContainer.Panel1Collapsed = !FoldersToolStripMenuItem.Checked;
        }

        private void FoldersToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //    ToggleFoldersVisible()
            ToggleFoldersVisible();
        }

        private void FoldersToolStripButton_Click(object sender, EventArgs e)
        {
            //    ToggleFoldersVisible()
            ToggleFoldersVisible();
        }

        private void SetView(System.Windows.Forms.View View)
        {
            //    'どのメニュー項目をチェックするかを設定します
            //    Dim MenuItemToCheck As ToolStripMenuItem = Nothing
            //    Select Case View
            //        Case View.Details
            //            MenuItemToCheck = DetailsToolStripMenuItem
            //        Case View.LargeIcon
            //            MenuItemToCheck = LargeIconsToolStripMenuItem
            //        Case View.List
            //            MenuItemToCheck = ListToolStripMenuItem
            //        Case View.SmallIcon
            //            MenuItemToCheck = SmallIconsToolStripMenuItem
            //        Case View.Tile
            //            MenuItemToCheck = TileToolStripMenuItem
            //        Case Else
            //            Debug.Fail("Unexpected View")
            //            View = View.Details
            //            MenuItemToCheck = DetailsToolStripMenuItem
            //    End Select
            //    '適切なメニュー項目をチェックし、[表示] メニューのその他の項目をすべて解除します
            //    For Each MenuItem As ToolStripMenuItem In ListViewToolStripButton.DropDownItems
            //        If MenuItem Is MenuItemToCheck Then
            //            MenuItem.Checked = True
            //        Else
            //            MenuItem.Checked = False
            //        End If
            //    Next
            //    '最後に、要求されたビューを設定します
            //    ListView.View = View
            //どのメニュー項目をチェックするかを設定します
            ToolStripMenuItem MenuItemToCheck = null;
            switch (View)
            {
                case View.Details:
                    MenuItemToCheck = DetailsToolStripMenuItem;
                    break;
                case View.LargeIcon:
                    MenuItemToCheck = LargeIconsToolStripMenuItem;
                    break;
                case View.List:
                    MenuItemToCheck = ListToolStripMenuItem;
                    break;
                case View.SmallIcon:
                    MenuItemToCheck = SmallIconsToolStripMenuItem;
                    break;
                case View.Tile:
                    MenuItemToCheck = TileToolStripMenuItem;
                    break;
                default:
                    System.Diagnostics.Debug.Fail("Unexpected View");
                    View = View.Details;
                    MenuItemToCheck = DetailsToolStripMenuItem;
                    break;
            }
            //適切なメニュー項目をチェックし、[表示] メニューのその他の項目をすべて解除します
            foreach (ToolStripMenuItem MenuItem in ListViewToolStripButton.DropDownItems)
            {
                if (object.ReferenceEquals(MenuItem, MenuItemToCheck))
                {
                    MenuItem.Checked = true;
                }
                else
                {
                    MenuItem.Checked = false;
                }
            }
            //最後に、要求されたビューを設定します
            ListView.View = View;
        }

        private void ListToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //    SetView(View.List)
            SetView(View.List);
        }

        private void DetailsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //    SetView(View. Details)
            SetView(View.Details);
        }

        private void LargeIconsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //    SetView(View.LargeIcon)
            SetView(View.LargeIcon);
        }

        private void SmallIconsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //    SetView(View.SmallIcon)
            SetView(View.SmallIcon);
        }

        private void TileToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //    SetView(View.Tile)
            SetView(View.Tile);
        }

        private void OpenToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //    Dim OpenFileDialog As New OpenFileDialog
            //    OpenFileDialog.InitialDirectory = My.Computer.FileSystem.SpecialDirectories.MyDocuments
            //    OpenFileDialog.Filter = "テキスト ファイル (*.txt)|*.txt"
            //    OpenFileDialog.ShowDialog(Me)

            //    Dim FileName As String = OpenFileDialog.FileName
            OpenFileDialog openFileDialog = new OpenFileDialog();
            openFileDialog.InitialDirectory = Environment.GetFolderPath(Environment.SpecialFolder.Personal);
            openFileDialog.Filter = @"テキスト ファイル (*.txt)|*.txt";
            openFileDialog.ShowDialog(this);

            String FileName = openFileDialog.FileName;
            //    ' TODO: ファイルを開くコードを追加します
        }

        private void SaveAsToolStripMenuItem_Click(object sender, EventArgs e)
        {
            //    Dim SaveFileDialog As New SaveFileDialog
            //    SaveFileDialog.InitialDirectory = My.Computer.FileSystem.SpecialDirectories.MyDocuments
            //    SaveFileDialog.Filter = "テキスト ファイル (*.txt)|*.txt"
            //    SaveFileDialog.ShowDialog(Me)

            //    Dim FileName As String = SaveFileDialog.FileName

            SaveFileDialog saveFileDialog = new SaveFileDialog();
            saveFileDialog.InitialDirectory = Environment.GetFolderPath(Environment.SpecialFolder.Personal);
            saveFileDialog.Filter = @"テキスト ファイル (*.txt)|*.txt";
            saveFileDialog.ShowDialog(this);

            String FileName = saveFileDialog.FileName;
            //    ' TODO: 現在のフォームの内容をファイルに保存するためのコードをここに追加します
        }

        private void TreeView_AfterSelect(object sender, TreeViewEventArgs e)
        {
            //    LoadListView(e.Node.FullPath)
            //    ' TODO: 現在選択されている treeview のノードに基づき listview の内容を変更するコードを追加します
            LoadListView(e.Node.FullPath);
        }
    }
}
